Bug 66908

Summary: Font-related tests are flaky on Chromium (sometimes glyphs don't draw)
Product: WebKit Reporter: Peter Kasting <pkasting>
Component: Tools / TestsAssignee: Mike Reed <reed>
Status: RESOLVED FIXED    
Severity: Normal CC: bashi, enne, jamesr, schenney, yutak
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on: 72459    
Bug Blocks:    

Description Peter Kasting 2011-08-24 17:39:56 PDT
The following layout test is flaky on Windows and Linux.

canvas/philip/tests/2d.text.draw.fontface.notinpage.html

Because this started failing not long after http://trac.webkit.org/changeset/93463/ , I suspect that it could have some kind of problem exposed by the increased parallelism in the test runner.

James suggests that since this is Windows + Linux and has to do with text, it may be a skia issue.  ->reed to triage.
Comment 1 Peter Kasting 2011-08-24 17:42:04 PDT
Sorry, left out some useful info.  This looks like a DEBUG-only failure that happens only on the GPU runs, not the CPU runs.  Here's a dashboard link:

http://test-results.appspot.com/dashboards/flakiness_dashboard.html#showExpectations=true&group=%40ToT%20GPU%20Mesa%20-%20chromium.org&tests=canvas%2Fphilip%2Ftests%2F2d.text.draw.fontface.notinpage.html
Comment 2 Mike Reed 2011-08-25 05:27:50 PDT
When I load this on my desktop, I see the custom font get loaded, but it appears that that happened after we drew the canvas, hence no text in the box. This may explain why it is flaky, and only succeeds sometimes.
Comment 3 Peter Kasting 2011-08-25 10:14:56 PDT
I'm wondering if http://test-results.appspot.com/dashboards/flakiness_dashboard.html#showExpectations=true&tests=fast%2Fcss%2Ffont-face-woff.html is flaky for the same reason.  This is another test that tries to render some text with a font and occasionally ends up just not drawing anything.
Comment 4 Peter Kasting 2011-08-25 13:13:29 PDT
Another test that sometimes doesn't draw all its glyphs ( http://test-results.appspot.com/dashboards/flakiness_dashboard.html#showExpectations=true&tests=svg%2Fcustom%2Fsvg-fonts-fallback.xhtml ):

svg/custom/svg-fonts-fallback.xhtml

Not sure whether these sorts of things are separate bugs or not.
Comment 5 Peter Kasting 2011-08-25 16:17:32 PDT
http://test-results.appspot.com/dashboards/flakiness_dashboard.html#showExpectations=true&tests=fast%2Fcss%2Ffont-face-multiple-faces.html shows a similar (no-glyphs) problem happening occasionally on Windows debug.
Comment 6 Yuta Kitamura 2011-11-07 23:35:14 PST
svg/custom/svg-fonts-segmented.xhtml looks same.

Looks like these tests contain the following bits:

<script>
    if (window.layoutTestController) {
        layoutTestController.waitUntilDone();
        document.documentElement.offsetTop;
        setTimeout(function() { layoutTestController.notifyDone(); }, 100);
    }
</script>

100ms may not be sufficient for slow bots (such as debug bots).
Comment 7 Adrienne Walker 2011-12-16 11:39:28 PST
Committed r103088: <http://trac.webkit.org/changeset/103088>
Comment 8 Stephen Chenney 2012-04-06 12:41:34 PDT
Apart form some rebaselining for Lion, these all look good now.
Comment 9 Stephen Chenney 2012-04-06 12:44:08 PDT
Committed r113482: <http://trac.webkit.org/changeset/113482>